{  doku: deutsche Version, see some lines down for english version

   **********************************************************************
   EnDiOBJ
   **********************************************************************

   Unit zur Implementation von Dialogelementen, die sich gegenseitig ein-
   und ausschalten.

   Bentigt:
    tp 7.0, bp 7.0
    tv 2.0

   Merkmale:
    keine nderungen in der INIT-Methode des aktivierenden Objekts
    standardisierte nderung in INIT-Methode des zu ndernden Objekts
    beliebig kombinierbar *ohne* zustzliche nderungen
    vererbbar

   TSendeObjekte:
    TSCheckBoxes
    TSRadioButtons
    TSInputline

   TReceiveObjekte
    TRInputLine
    TRCheckBoxes
    TRRadiobuttons
    TRButton
    TRHistory      (Kennt den Status seiner TRInputLine)
    TRLabel        (Kennt den Status seiner TRInputline, TRCheckboxes
                                             TRRadiobuttons)

   TRSLogikObjekt
    TRSLogik


   Erweiterte Init-Felder:
     Aselmask : Wenn das zugeordnete TS-Objekt diesen Zustand hat, dann
                schaltet das TR-Objekt in den Amymask-Zustand um
                - TSInputline
                  Reaktion auf Feld leer bzw. nicht leer (data^<>'')
                - TSCheckboxes
                  Zustandsmaske stimmt berein (value and aselmask<>0)
                - TSRadiobuttons
                  Zustand ist gesetzt (value=aselmask)
                - TRSLogik
                   1 : ein AND des Zustands beider Chefs
                   2 : ein OR  des Zustands beider Chefs
                   3 : ein XOR des Zustands beider Chefs

     Amymask  : TR-Objekt schaltet sich in diesen Zustand, wenn der Zustand
                nach Aselmask zutrifft. Voreingestellt ist: An.
                - trinputline, trbutton
                  schaltet sich ab
                - trcheckboxes, trradiobuttons
                  schaltet die einzelnen Items ab

                Eine Maske kleiner Null invertiert die logische Bedingung,
                bedeutet also "Voreingestellt ist: Aus" und "schaltet an".

                Eine Maske gleich Null ist Bldsinn.

     Aobjekt  : Zeiger auf das TS-Objekt, auf das das TR-Objekt hren soll
                ("Chef")



   doku: english version, nach oben gucken fr die deutsche version

   Unit to implement dialogelements that en- and disable themself mutual.

   Needs:
    tp 7.0, bp 7.0
    tv 2.0

   Characteristics:
    no changes within the INIT-methode of the activating object
    standard change within the init-method of the changing objects
    any combinations *without* extra changes
    inherited possible

   TSendeObjects:
    TSCheckBoxes
    TSRadioButtons
    TSInputline

   TReceiveObjekte
    TRInputLine
    TRCheckBoxes
    TRRadiobuttons
    TRButton
    TRHistory      (knows the status of his TRInputLine)
    TRLabel        (knows the status of his TRInputline, TRCheckboxes
                                             TRRadiobuttons)

   TRSLogikObjekt
    TRSLogik

   enhanced init-variables:
     Aselmask : if the attached TS-object has this state, the TR-object will
                change his state to that given in Amymask
                - TSInputline
                  changes if field empty or not empty (data^<>'')
                - TSCheckboxes
                  selectionsmasks fit together (value and aselmask<>0)
                - TSRadiobuttons
                  value ist set (value=aselmask)
                - TRSLogik
                   1 : an AND between the state of both chiefs
                   2 : an OR  between the state of both chiefs
                   3 : a  XOR between the state of both chiefs

     Amymask  : TR-object will switch to this state if the Aselmask-condition
                is true
                default is: ON
                - trinputline, trbutton
                  disable
                - trcheckboxes, trradiobuttons
                  disable the masked items

                If mask is less zero, the logical condition will be inverted,
                so "default is off" and "enables"

                A mask equal zero is silly.

     Aobjekt  : Pointer to the TS-object, the TR-object shall listen to.
                ("chief")


   and again, german language

   Versionsgeschichte:
    V1.7   19.05.93    Bugfix: SET...STATE bei TR-Objekten
                                (Vorauseilender Gehorsam)
    V1.6   10.05.93    Checkaktiv eingefhrt (Codeoptimierung)
                        TRSLogik eingebaut
                        Bugfix: TRButton
    V1.5   08.05.93    Einbau der CommArea wg. Vererbung
                        (so ist alles viel einfacher, TypeOf-Speicher raus!)
    V1.4   23.04.93    Typeof-Speicher eingebaut (wg. Vererbbarkeit)
    V1.3   12.04.93    Ergnzung um inversen Status
    V1.2   11.04.93    SetState in TButton.Handleevent ergnzt
    V1.1   06.04.93    Optimierte Inputline
    V1.1   05.04.93    Fixes bei Buttons
    V1.0   05.04.93    Implementation, Fixes bei TS-Setstate


   Autor: KAP Holger Lembke, Hamburger Strae 284, 38114 Braunschweig; Germany

   Tel:   +49-531-334676

   EMail: holgi@kap.escape.de;
          100112,3517;
          Holger Lembke @ 2:241/500.20;
          Holger_Lembke@BDB.ZER;
          Holger Lembke @ PE.maus.de


   Benutzungslizenz, Agreement of Use:
    Diese Sammlung darf im privaten Einsatz uneingeschrnkt verwendet
     werden.
     Sobald sie in irgendeiner Form dazu verwendet wird, Geld zu verdienen
     (auch als gewerbliche Anwendung bekannt), muss sie gekauft werden.
     Setzen Sie sich dazu mit mir in Verbindung. Benutzen Sie dazu
     ORDER.DOK.

    This collection is free, if it is used private.
     If it is used in any way to earn money (know as commercial use) it
     must be bought.
     Contact me. See ORDER.DOK for details.


   **********************************************************************
   **********************************************************************
}

{$ifndef ver70 }
                     Hurz! Nur Mit TP 7.0 kompilierbar
{$endif }

{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}


unit endiobj;

interface


uses views, objects, dialogs, drivers;


Const cmselectchanged   = 65000;
      cmupdateall       = 65001;

type
   pcommarea = ^commarea;
   commarea  = record
     mytype : pointer;
     myself : pointer;
   end;
{  **********************************************************************  }
{  **********************************************************************  }
{  TS-Objekte                                                              }
{    erzeugen beim Aendern ihres Inhaltes eine EVBroadcast,               }
{     die von allen TR-Objekte empfangen wird. Die Reaktion                }
{     auf die Botschaft entscheiden die TR-Objekte universell.             }
{    Die Objekte sind direkte Nachfahren ohne wesentliche nderungen.     }
{                                                                          }
{    will post a evbroadcasr-message if the containing data changes       }
{     the message will be received by all TR-objects                       }
{    the objects are direct descendants without important changes         }
{  **********************************************************************  }
{  **********************************************************************  }
  pScheckboxes = ^tScheckboxes;
  tscheckboxes = object(tcheckboxes)
    constructor Init(var Bounds: TRect; AStrings: PSItem);
    procedure   handleevent(var event : tevent); virtual;
    procedure   SetData(var Rec); virtual;
  end;

  pSradiobuttons = ^tSradiobuttons;
  tsradiobuttons = object(tradiobuttons)
    constructor Init(var Bounds: TRect; AStrings: PSItem);
    procedure   handleevent(var event : tevent); virtual;
    procedure   SetData(var Rec); virtual;
  end;

  pSinputline = ^tSinputline;
  tsinputline = object(tinputline)
    constructor Init(var Bounds: TRect; AMaxLen: Integer);
    procedure   handleevent(var event : tevent); virtual;
    procedure   SetData(var Rec); virtual;
  end;




{  **********************************************************************  }
{  **********************************************************************  }
{  TR-Objekte                                                              }
{    kennen ihren Chef und reagieren auf dessen nderung mit Ein-         }
{     oder Ausschalten                                                     }
{    TR-Objekte sind universell, dh. sie kennen alle TS-Objekte und       }
{     reagieren differenziert                                              }
{                                                                          }
{    know their chief and respond on changes with en- or disabling        }
{    TR-objects are universal, i.e. they know all TS-objects an respond   }
{     divernetly                                                           }
{  **********************************************************************  }
{  **********************************************************************  }



{  **********************************************************************  }
{  **********************************************************************  }
{  Inputline-Nachfahre                                                     }
{  **********************************************************************  }
{  **********************************************************************  }
  pRinputline = ^tRinputline;
  trinputline = object(tinputline)
    constructor init(var Bounds: TRect;
                         AMaxLen  : Integer;
                         Aselmask : longint;
                         Amymask  : longint;
                         Aobjekt  : pointer);
    procedure handleevent(var event : tevent); virtual;
    function  GetPalette: PPalette; virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  Checkboxes-Nachfahre                                                    }
{  **********************************************************************  }
{  **********************************************************************  }
  pRcheckboxes = ^tRcheckboxes;
  trcheckboxes = object(tcheckboxes)
    constructor init(var Bounds: TRect;
                         AStrings : PSItem;
                         Aselmask,
                         Amymask  : longint;
                         Aobjekt  : pointer);
    procedure handleevent(var event : tevent); virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  Radiobuttons-Nachfahre                                                  }
{  **********************************************************************  }
{  **********************************************************************  }
  pRradiobuttons = ^tRradiobuttons;
  trradiobuttons = object(tradiobuttons)
    constructor init(var Bounds: TRect;
                         AStrings : PSItem;
                         Aselmask,
                         Amymask  : longint;
                         Aobjekt  : pointer);
    procedure handleevent(var event : tevent); virtual;
    procedure SetData(var Rec); virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  Button-Nachfahre                                                        }
{  **********************************************************************  }
{  **********************************************************************  }
  pRbutton = ^tRbutton;
  trbutton= object(tbutton)
    constructor init(var Bounds   : TRect;
                         ATitle   : TTitleStr;
                         ACommand : Word;
                         AFlags   : Byte;
                         Aselmask : longint;
                         Amymask  : longint;
                         Aobjekt  : pointer);
    procedure handleevent(var event : tevent); virtual;
    function  GetPalette: PPalette; virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  History-Nachfahre                                                       }
{  **********************************************************************  }
{  **********************************************************************  }
  pRhistory = ^tRhistory;
  trhistory = object(thistory)
    constructor init(var Bounds     : TRect;
                         ALink      : pointer;
                         AHistoryId : Word);
    procedure handleevent(var event : tevent); virtual;
    procedure draw; virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  Label-Nachfahre                                                         }
{  **********************************************************************  }
{  **********************************************************************  }
  pRlabel = ^tRlabel;
  trlabel = object(tlabel)
    constructor init(var Bounds     : TRect;
                         atext      : string;
                         ALink      : pointer);
    procedure handleevent(var event : tevent); virtual;
    function  GetPalette: PPalette; virtual;
  end;


{  **********************************************************************  }
{  **********************************************************************  }
{  TRS-Objekte                                                             }
{    sind logische Objekte, die Verknpfungen herstellen knnen           }
{    haben zwei Chefs                                                     }
{                                                                          }
{    are logic objects that build conjuctions                             }
{    have two chiefs                                                      }
{  **********************************************************************  }
{  **********************************************************************  }

{  **********************************************************************  }
{  **********************************************************************  }
{  Logic Objekt                                                            }
{  **********************************************************************  }
{  **********************************************************************  }
  prslogik = ^trslogik;
  trslogik = object(tinputline)
    constructor init(Aselmask,
                     Amymask   : longint;
                     Aobjekt1,
                     Aobjekt2  : pointer);
    procedure handleevent(var event : tevent); virtual;
    procedure draw; virtual;
    function  datasize:word; virtual;
    procedure GetData(var Rec); virtual;
    procedure SetData(var Rec); virtual;
  end;



implementation

{it's me, a uninit unit }
end.
