// junkview.cpp : implementation of the CJunkView class
//

#include "stdafx.h"
#include "junk.h"
    
#include "junkdoc.h"
#include "junkview.h"
#include "mainfrm.h"    

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJunkView

IMPLEMENT_DYNCREATE(CJunkView, CEditView)

BEGIN_MESSAGE_MAP(CJunkView, CEditView)
	//{{AFX_MSG_MAP(CJunkView)
	ON_UPDATE_COMMAND_UI(ID_EDIT_ROW, OnUpdateEditRow)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COLUMN, OnUpdateEditColumn)
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SETFOCUS()
	ON_EN_CHANGE(AFX_IDW_PANE_FIRST, OnEditChange)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJunkView construction/destruction

CJunkView::CJunkView()
{
	// TODO: add construction code here
}

CJunkView::~CJunkView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CJunkView drawing

void CJunkView::OnDraw(CDC* pDC)
{
	CJunkDoc* pDoc = GetDocument();

	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CJunkView printing

BOOL CJunkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CJunkView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Just do the default.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CJunkView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Just do the default.
	CEditView::OnEndPrinting(pDC, pInfo);
}




/////////////////////////////////////////////////////////////////////////////
// CJunkView diagnostics

#ifdef _DEBUG
void CJunkView::AssertValid() const
{
	CView::AssertValid();
}

void CJunkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CJunkDoc* CJunkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CJunkDoc)));
	return (CJunkDoc*) m_pDocument;
}

#endif //_DEBUG
                                
                                
/////////////////////////////////////////////////////////////////////////////
// CJunkView message handlers                                 
      
      
//      
// ***********************************************************************
// 	  Below are handlers for the messages we need to trap to keep track
// 	  of the caret.  Note that the default behavior is always called
// 	  before we figure out where the caret is.
// ***********************************************************************
//                                
  
  
//                                
// The OnKeyUp() and OnKeyDown() are used to trap not only character keys
// (a-z, A-Z, 0-9, etc.), but also the editing keys, such as the left
// arrow key, or the PgDn key.
//
void CJunkView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CEditView::OnKeyUp(nChar, nRepCnt, nFlags);
	DisplayCaretPosition();
}

void CJunkView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CEditView::OnKeyDown(nChar, nRepCnt, nFlags);
	DisplayCaretPosition();
}

void CJunkView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CEditView::OnLButtonDown(nFlags, point);
	DisplayCaretPosition();
}

void CJunkView::OnSetFocus(CWnd* pOldWnd)
{
	CEditView::OnSetFocus(pOldWnd);
	DisplayCaretPosition();
}

void CJunkView::OnMouseMove(UINT nFlags, CPoint point)
{
	CEditView::OnMouseMove(nFlags, point);
	
	// Here we just update the caret position indicators only for
	// when the mouse is being moved during a text selection.
	if (nFlags != 0)
	{
		DisplayCaretPosition();
	}		
}

//
// We trap this message because the user can double-click and highlight
// a whole word at a time.  The caret moves when that is done.
// 
void CJunkView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CEditView::OnLButtonDblClk(nFlags, point);
	DisplayCaretPosition();
}
     
//
// Overridden from the CEditView class.  This helps to trap situations such
// as using WM_SETTEXT to change the contents of the edit window, or the
// standard stuff like cutting and pasting.
//                                  
void CJunkView::OnEditChange(void)
{    
	CEditView::OnEditChange();
	DisplayCaretPosition();
} 

                   
                   
//
// The next 2 routines make sure the row/column indicator panes on the
// status bar are always enabled so the text will display.
//                                
void CJunkView::OnUpdateEditRow(CCmdUI* pCmdUI)
{                                 
	pCmdUI->Enable(TRUE);
}

void CJunkView::OnUpdateEditColumn(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(TRUE);
}


//
// The following function is where we figure out where the edit field
// caret is.  The function also updates the status bar.
//           
void CJunkView::DisplayCaretPosition(void)
{
    static UINT nOldEnd;
    static UINT nOldLineIndex;
    static UINT nLastRow;
                          
	BOOL   		bSelection = FALSE;
                          
	//      
	// First, get number of the line the caret is on.
	//    
	UINT nRowNumber = (UINT)SendMessage(EM_LINEFROMCHAR, -1, 0L);
	nRowNumber++;		// zero-based
	
	//      
    // Send the EM_GETSEL message to the edit control.  The low-order
    // word of the return value is the character position of the caret
    // relative to the first character in the edit control.
	//      
    DWORD dwGetSel = (DWORD)SendMessage(EM_GETSEL, 0, 0L);
    UINT  nStart   = (UINT)LOWORD(dwGetSel);
    UINT  nEnd     = (UINT)HIWORD(dwGetSel);
    
	//
    // Test here if we are in the middle of a selection.  The reason we
    // keep STATIC variables for the former positions is to determine in
    // which direction the text selection is going in.
    // (right->left or left->right).
	//
    if (nEnd != nStart)
    {
    	bSelection = TRUE;
    	if (nEnd > nOldEnd)
    	{
    		nStart = nEnd;
		}
	}		    		
	else
	{
		bSelection 	= FALSE;
		nOldEnd 	= nEnd;
		nLastRow 	= nRowNumber;
	}	
    	
	//      
    // Send the EM_LINEINDEX message with a WPARAM value of -1.  The
    // return value is the absolute number of characters that preceed
    // the first character in the line that contains the caret.
    // Here we also test the previous value when we are under a selection
    // to see if the line number has changed.  This is because when the
    // user is doing a selection, the EM_LINEFROMCHAR message returns the
    // starting line of a selection, not the current caret line.
	//      
    UINT nLineIndex = (UINT)SendMessage(EM_LINEINDEX, -1, 0L);
    if (bSelection)
    {
	    if (nLineIndex > nOldLineIndex)
	    {                
	    	// we've gone down a line during a selection
	    	nRowNumber = ++nLastRow;
		}
		else if (nLineIndex < nOldLineIndex)
		{                
			// we've gone up a line during a selection
	    	nRowNumber = --nLastRow;
		}	    	
		else
		{
			nRowNumber = nLastRow;
		}			
    }
    
   	nOldLineIndex = nLineIndex;
    
    //
    // Now subtract the LineIndex from the start of the selection,
    // then add 1 (column is also zero-based).  The result is the
    // column number of the caret position.
    //
	UINT nColumnNumber = (nStart - nLineIndex) + 1;

    
    //
    // Now display the row and column in the status bar panes.  This 
    // section formats the numbers so they are zero filled to the left.
    // (Just like the VC++ editor)
	//    
	char szTemp1[6];
	char szTemp2[6];
	CStatusBar *StatusBar = (((CJunkApp *)AfxGetApp())->GetMainFrame())->GetStatusBar();                 
	
	strcpy(szTemp1, "00000");
	itoa(nRowNumber, szTemp2, 10);
	int pos = (strlen(szTemp1) - strlen(szTemp2));
	if (pos <= (int)strlen(szTemp1))
	{
		strcpy(szTemp1 + pos, szTemp2);
		StatusBar->SetPaneText(3, szTemp1, TRUE);		// Update status bar
	}		
	
	strcpy(szTemp1, "000");
	itoa(nColumnNumber, szTemp2, 10);
	pos = (strlen(szTemp1) - strlen(szTemp2));
	if (pos <= (int)strlen(szTemp1))
	{
		strcpy(szTemp1 + pos, szTemp2);
		StatusBar->SetPaneText(4, szTemp1, TRUE);		// Update status bar
	}                    
}


